// Generated by CoffeeScript 1.6.1
/*
	FlexNav.js 0.6.1

	Copyright 2013, Jason Weaver http://jasonweaver.name
	Released under the WTFPL license
	http://sam.zoy.org/wtfpl/

//
*/
(function() 
{
    $.fn.flexNav = function(options) 
    {
        var $nav, nav_count, settings, transition;
        
        settings = $.extend(
        {
            'transitionSpeed': '0.3s',
            'itemHeight': 40
        }, options);
        
        $nav       = $(this);
        transition = 'all ' + settings.transitionSpeed + ' ease-in-out';
        
        $nav.find("li").each(function() 
        {
            var $sub_nav, count;
            if ($(this).has("ul").length) 
            {
                $(this).addClass("item-with-ul");
                
                $sub_nav = $(this).find('>ul');
                count    = $sub_nav.find('li').length;
                
                $sub_nav.attr("data-height", settings.itemHeight * count);
                
                return $nav.attr("data-height", settings.itemHeight * count);
            }
        });
        
        nav_count = $nav.find('li').length;
        
        $nav.attr("data-height", settings.itemHeight * nav_count);
        
        /* should be removed for mobile devices */
        $('.flexnav li').on('mouseenter', function() 
        {
            $(this).find('ul').css('opacity', '1');
            $(this).find('ul > li').css('max-height', '50px');
            
        }).on('mouseleave', function() 
        {
            $(this).find('ul').css('opacity', '0');
            $(this).find('ul > li').css('max-height', '0');
            
        });
        
        
        $('.flexnav > li.m_show').on('click', function() 
        {
            var ul      = $(this).find('ul');
            var visible = ul.css('opacity') + '';
            
            if (visible == '1') 
            {
                ul.css('opacity', '0');
                ul.find('> li').css('max-height', '0');
                
            } 
            else 
            {
                $('.flexnav li ul').css('opacity', '0');
                $('.flexnav li ul > li').css('max-height', '0');
                
                ul.css('opacity', '1');
                ul.find('>li').css('max-height', '50px');
            }
            
        });
        
        $('.flexnav li.m_show ul').on('click', function(e) 
        {
            e.stopPropagation();
            
            $(this).css('opacity', '0');
            $(this).find('> li').css('max-height', '0');
        });
    };


    function is_touch_device() 
    {
        try 
        {
            return ("ontouchstart" in document.documentElement);
            
        } catch (e) 
        {
            return false;
            
        }
    }
    
}).call(this);